<!DOCTYPE html>
<html lang="en">
<head>
  <title>pizza365ForStaff</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h2 class="text-center">DANH SÁCH ĐƠN HÀNG</h2>
        <div class="container jumbotron">
            <div class="row form-group">
                <div class="col-md-2">
                    <label>Trạng thái Order:</label>
                </div>
                <div class="col-md-3">
                    <select id="select-trang-thai" class="form-control">
                        <option value="all">All</option>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>
                    </select>
                </div>
                <div class="col-md-2">
                    <label>Loai Pizza:</label>
                </div>
                <div class="col-md-3">
                    <select id="select-loai-pizza" class="form-control">
                        <option value="all">All</option>
                        <option value="hawaii">Hawaii</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>
                    </select>
                </div>
                <div class="col-md-2">
                    <button id="btn-filter" class="btn btn-primary form-control">Lọc</button>
                </div>
            </div>
        </div>
        <table id="table-order" class="table table-bordered table-hover table-striped table-warning text-center">
            <thead>
                <tr>
                    <th scope="col">Order Id</th>
                    <th scope="col">Kích cỡ Combo</th>
                    <th scope="col">Loại Pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>
                
            </tbody>
        </table>
    </div>

    <!-- Vùng Modal -->
    <div>
        <div class="modal fade" id="modal-update-order" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Order Detail!!!</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>OrderID:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-order-id" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Có Combo:</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-modal-kich-co" class="form-control">

                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Đường kính Pizza:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-duong-kinh" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Sườn nướng (cây):</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-suon" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Đồ uống:</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-modal-do-uong" class="form-control">
                                    
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Số lượng nước uống:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-so-luong-nuoc" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>VoucherID:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-voucher-id" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Loại Pizza:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-loai-pizza" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Salad (gr):</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-salad" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Thành tiền:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-thanh-tien" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Giảm giá:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-giam-gia" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Họ và tên:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-ho-ten" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Email:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-email" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Số điện thoại:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-so-dien-thoai" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Địa chỉ:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-dia-chi" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Lời nhắn:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-loi-nhan" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Trạng thái đơn hàng:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-trang-thai" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Ngày tạo đơn:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-ngay-tao" class="form-control"/>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Ngày cập nhật:</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="inp-modal-ngay-cap-nhat" class="form-control"/>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="btn-modal-confirm" class="btn btn-success">Confirm</button>
                        <button type="button" id="btn-modal-cancel" class="btn btn-danger">Cancel</button>
                    </div>
                </div>
            </div>
          </div>
    </div>
    
</body>

<script>
    "use strict";
    $(document).ready(function() {
        // Vùng 1: Khai báo biến toàn cục
        var gOrdersDb = {
            order: [],
            filterOrder: function(paramFilter) {
                var vResult = [];
                // Lọc
                vResult = this.order.filter(function(order) {
                    return ((paramFilter.trangThai == "all" || paramFilter.trangThai.toLowerCase() == order.trangThai.toLowerCase()) &&
                            (paramFilter.loaiPizza == "all" || paramFilter.loaiPizza.toLowerCase() == order.loaiPizza.toLowerCase()))
                });
                return vResult;
            }
        }

        const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";

        const gNAME_COLS = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];

        const gORDER_ID_COL = 0;
        const gKICH_CO_COL = 1;
        const gLOAI_PIZZA_COL = 2;
        const gNUOC_UONG_COL = 3;
        const gTHANH_TIEN_COL = 4;
        const gHO_VA_TEN_COL = 5;
        const gSO_DIEN_THOAI_COL = 6;
        const gTRANG_THAI_COL = 7;
        const gCHI_TIET_COL = 8;

        var gId;
        var gOrderId;
        var gComboSize = ["S", "M", "L"];

        var gTableOrder = $('#table-order').DataTable({
            "columns": [
                { "data": gNAME_COLS[gORDER_ID_COL] },
                { "data": gNAME_COLS[gKICH_CO_COL] },
                { "data": gNAME_COLS[gLOAI_PIZZA_COL] },
                { "data": gNAME_COLS[gNUOC_UONG_COL] },
                { "data": gNAME_COLS[gTHANH_TIEN_COL] },
                { "data": gNAME_COLS[gHO_VA_TEN_COL] },
                { "data": gNAME_COLS[gSO_DIEN_THOAI_COL] },
                { "data": gNAME_COLS[gTRANG_THAI_COL] },
                { "data": gNAME_COLS[gCHI_TIET_COL] }
            ],
            "columnDefs": [
                {
                    "targets": gCHI_TIET_COL,
                    "defaultContent": "<button class='btn btn-primary btn-detail'>Chi tiết</button>"
                }
            ]
        });


        // Vùng 2: Vùng gán
        onPageLoading();
        getDrinkListAjaxClick();
        getComboSizeList(gComboSize)

        $(document).on('click', '#table-order .btn-detail', function() {
            onBtnDetailClick(this);
        });

        $('#btn-filter').on('click', onBtnFilterClick);

        $('#btn-modal-confirm').on('click', onBtnModalConfirmClick);
        $('#btn-modal-cancel').on('click', onBtnModalCancelClick);

        // Vùng 3: Khai báo hàm xử lý sự kiện
        // Hàm xử lý khi tải trang
        function onPageLoading() {
            "use strict";
            console.log("Load trang");
            //B1: thu thập dữ liệu (k có)
            //B2: validate dữ liệu (k có)
            //B3: Call api
            callApiGetAllOrders();
            //B4: Xử lý hiển thị
            loadDataToDataTable(gOrdersDb.order);
        }

        // Hàm xử lý khi click các button detail
        function onBtnDetailClick(paramEle) {
            "use strict";
            var vRowClick = $(paramEle).closest('tr');
            var vTable = $('#table-order').DataTable();
            var vDataRow = vTable.row(vRowClick).data();
            console.log(vDataRow);
            gId = vDataRow.id;
            gOrderId = vDataRow.orderId;
            console.log("gId: " + gId + " gOrderId: " + gOrderId);

            $("#modal-update-order").modal("show");
            callApiGetOrderByOrderId();
        }

        // Hàm xử lý khi click filter btn
        function onBtnFilterClick() {
            "use strict";
            //B1: Tạo đối tượng lưu trữ và thu thập dữ liệu
            var vFilterObj = {
                trangThai: "",
                loaiPizza: ""
            };
            getFilterData(vFilterObj);
            console.log(vFilterObj);

            //B2: validate (k cần)

            //B3: Lọc dữ liệu
            var vFilterOrder = gOrdersDb.filterOrder(vFilterObj);

            //B4: Hiển thị
            loadDataToDataTable(vFilterOrder);
        }

        // Hàm xử lý khi click btn confirm in modal
        function onBtnModalConfirmClick() {
            "use strict";
            var vObjectRequest = {
                trangThai: "confirmed"
            };
            callApiUpdateOrder(vObjectRequest);
            
        }

        // Hàm xử lý khi click btn cancel in modal
        function onBtnModalCancelClick() {
            "use strict";
            var vObjectRequest = {
                trangThai: "cancel"
            };
            callApiUpdateOrder(vObjectRequest);
        }

        // Vùng 4: Khai báo hàm dùng chung
        // Hàm call api lấy toàn bộ orders
        function callApiGetAllOrders() {
            "use strict";
            $.ajax({
                url: gBASE_URL,
                type:'GET',
                dataType: 'json',
                async: false,
                success: function(result) {
                    gOrdersDb.order = result;
                    console.log(gOrdersDb.order);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        // Hàm load data vào table
        function loadDataToDataTable(paramOrder) {
            "use strict";
            gTableOrder.clear();
            gTableOrder.rows.add(paramOrder);
            gTableOrder.draw();
        }

        // Hàm thu thập data filter
        function getFilterData(paramFilterObj) {
            "use strict";
            paramFilterObj.trangThai = $('#select-trang-thai :selected').val();
            paramFilterObj.loaiPizza = $('#select-loai-pizza :selected').val();
        }

        // Hàm call api get order by order id
        function callApiGetOrderByOrderId() {
            "use strict";
            $.ajax({
                url: gBASE_URL + "/" + gOrderId,
                type: 'GET',
                dataType: 'json',
                async: false,
                success: function(result) {
                    console.log(result);
                    loadDataToModalInput(result);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        // Hàm load data vào input trong modal
        function loadDataToModalInput(paramResult) {
            "use strict";
            $('#inp-modal-order-id').val(paramResult.orderId);
            $('#select-modal-kich-co').val(paramResult.kichCo.toLowerCase());
            $('#inp-modal-duong-kinh').val(paramResult.duongKinh);
            $('#inp-modal-suon').val(paramResult.suon);
            $('#select-modal-do-uong').val(paramResult.idLoaiNuocUong);
            $('#inp-modal-so-luong-nuoc').val(paramResult.soLuongNuoc);
            $('#inp-modal-voucher-id').val(paramResult.idVourcher);
            $('#inp-modal-loai-pizza').val(paramResult.loaiPizza);
            $('#inp-modal-salad').val(paramResult.salad);
            $('#inp-modal-thanh-tien').val(paramResult.thanhTien);
            $('#inp-modal-giam-gia').val(paramResult.giamGia);
            $('#inp-modal-ho-ten').val(paramResult.hoTen);
            $('#inp-modal-email').val(paramResult.email);
            $('#inp-modal-so-dien-thoai').val(paramResult.soDienThoai);
            $('#inp-modal-dia-chi').val(paramResult.diaChi);
            $('#inp-modal-loi-nhan').val(paramResult.loiNhan);
            $('#inp-modal-trang-thai').val(paramResult.trangThai);
            $('#inp-modal-ngay-tao').val(paramResult.ngayTao);
            $('#inp-modal-ngay-cap-nhat').val(paramResult.ngayCapNhat);
        }

        // Hàm gọi api select drink
        function getDrinkListAjaxClick() {
            "use strict";
            $.ajax({
                url: "http://42.115.221.44:8080/devcamp-pizza365/drinks",
                type: 'GET',
                dataType: 'json',
                success: function(result) {
                    handleDrinkList(result);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        // Hàm tạo option cho select đồ uống
        function handleDrinkList(paramResult) {
            "use strict";
            $.each(paramResult, function(i, item) {
                $('#select-modal-do-uong').append($('<option>', {
                    text: item.tenNuocUong,
                    value: item.maNuocUong
                }));
            });
        }

        // Hàm tạo option cho combosize
        function getComboSizeList(paramSize) {
            "use strict";
            console.log(paramSize);
            $.each(paramSize, function(i, item) {
                $('#select-modal-kich-co').append($('<option>', {
                    text: item,
                    value: item.toLowerCase()
                }));
            });
        }

        // Hàm update confirm order
        function callApiUpdateOrder(paramRequest) {
            "use strict";
            $.ajax({
                url: gBASE_URL + "/" + gId,
                type: 'PUT',
                dataType: 'json',
                contentType: "application/json;charset=UTF-8",
                async: false,
                data: JSON.stringify(paramRequest),
                success: function(result) {
                    console.log(result);
                    $("#modal-update-order").modal("hide");
                    callApiGetAllOrders();
                    loadDataToDataTable(gOrdersDb.order);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

    });
</script>

</html>